#delimit;
clear all;
set mem 1G;
set more off;
set varabbrev off;

local data_dir "Data";
local output_dir "Output";
local alt_sort 0;				/* =1 sort by fraction of world trade, =0 sort by trade value*/

*************************************************Table 3***********************************************************************************;
/*
local file_name "canmex8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "mexcan8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "canusa8899";
local base_year = "1988";
local end_year = "1998";
local years_2 = "1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1988 y1989 y1990";
local world_range = "world_total_value1988 world_total_value1989 world_total_value1990";
*/
/*
local file_name "usacan8899";
local base_year = "1988";
local end_year = "1998";
local years_2 = "1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1988 y1989 y1990";
local world_range = "world_total_value1988 world_total_value1989 world_total_value1990";
*/
/*
local file_name "mexusa8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "usamex8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
****************************************************End table 3*************************************************************************************;

****************************************************Start table 4***********************************************************************************;
/*
local file_name "chnusa9505";
local base_year = "1995";
local end_year = "2005";
local years_2 = "1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005";
local sort_range = "y1995 y1996 y1997";
local world_range = "world_total_value1995 world_total_value1996 world_total_value1997";
*/
/*
local file_name "usachn9505";
local base_year = "1995";
local end_year = "2005";
local years_2 = "1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005";
local sort_range = "y1995 y1996 y1997";
local world_range = "world_total_value1995 world_total_value1996 world_total_value1997";
*/
/*
local file_name "korusa7585";
local base_year = "1975";
local end_year = "1985";
local years_2 = "1975 1976 1977 1978 1979 1980 1981 1982 1983 1984 1985";
local sort_range = "y1975 y1976 y1977";
*/
/*
local file_name "usakor7585";
local base_year = "1975";
local end_year = "1985";
local years_2 = "1975 1976 1977 1978 1979 1980 1981 1982 1983 1984 1985";
local sort_range = "y1975 y1976 y1977";
*/
/*
local file_name "usachl7585";
local base_year = "1975";
local end_year = "1985";
local years_2 = "1975 1976 1977 1978 1979 1980 1981 1982 1983 1984 1985";
local sort_range = "y1975 y1976 y1977";
*/
/*
local file_name "chlusa7585";
local base_year = "1975";
local end_year = "1985";
local years_2 = "1975 1976 1977 1978 1979 1980 1981 1982 1983 1984 1985";
local sort_range = "y1975 y1976 y1977";
*/
****************************************************End table 4*************************************************************************************;

****************************************************Start table 5***********************************************************************************;
/*
local file_name "gerusa8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "usager8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "jpnusa8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "usajpn8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "ukkusa8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "usaukk8999";
local base_year = "1989";
local end_year = "1999";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
****************************************************End table 5*************************************************************************************;


****************************************************For figure 8************************************************************************************;
/*
local file_name "canmex8906";
local base_year = "1989";
local end_year = "2006";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "mexcan8906";
local base_year = "1989";
local end_year = "2006";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "usachn8906";
local base_year = "1989";
local end_year = "2006";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
/*
local file_name "chnusa8906";
local base_year = "1989";
local end_year = "2006";
local years_2 = "1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006";
local sort_range = "y1989 y1990 y1991";
local world_range = "world_total_value1989 world_total_value1990 world_total_value1991";
*/
***********************************************************************************************************************;
***********************************************************************************************************************;

*************************************set the filenames*****************************************************************;
if(`alt_sort' == 0){;
	local filename_bar = "`output_dir'" + "\" + "`file_name'" + "_bar.txt";
	local filename_tss = "`output_dir'" + "\" + "`file_name'" + "_tss.txt";
};
if(`alt_sort' == 1){;
	local filename_bar = "`output_dir'" + "\" + "`file_name'_bar_alt.txt";
	local filename_tss = "`output_dir'" + "\" + "`file_name'_tss_alt.txt";
};


***************************load the data, fix the filenames************************************************************;
local temp_in =  "`data_dir'" + "\" + "`file_name'.txt";
insheet using `temp_in';
rename v1 code;
local temp = 1;
foreach j in `years_2'{;
	local temp = `temp' + 1;
	rename v`temp' y`j';
};
***********************************************************************************************************************;

******** Sort by share of world trade**********************************************************************************;
if(`alt_sort' == 1){;	
	local temp_merge = "`data_dir'" + "\" + "total_by_good_year_8806.dta";
	merge 1:1 code using `temp_merge'; 

	forvalues i=1988(1)2006{;
		replace world_total_value`i' = 0 if world_total_value`i'==.;
	};

	egen temp = rowmean(`world_range');
	egen sort_var = rowmean(`sort_range');
	replace sort_var = sort_var/temp;
	replace sort_var = 0 if temp == 0;
	drop temp;
	};
	
	
***Sort by value ***********************************************************************************************************;
if (`alt_sort' == 0){;
	egen sort_var = rowmean(`sort_range');
};
	
sort sort_var;

foreach i in `years_2'{;
	egen y`i'_total = total(y`i');
};

gen y`base_year'_frac = y`base_year'/y`base_year'_total;
gen y`base_year'_cum = sum(y`base_year'_frac);

forvalues i = 1(1)10{;
	gen bin`i'=0;
};


local cum_sum = 0;
local cum_sum_old=0;
local lower = 0;
local upper = 0.10;
local bin_num = 1;

**Determine which goods are in each bin.*********************************************;
forvalues i = 1(1)`=_N'{;

	local cum_sum = `cum_sum_old' + y`base_year'_frac[`i'];
	
	**Somtimes you get a zero value code at the end (averaging over the 3 years makes this possible);
	if ( (1.0 - `cum_sum') < 0.0001 ){;
		di "in";
		replace bin10 =  1 in `i';
	};
	*************************************************************************************************;
	
		
	if (`cum_sum' < 1.0){;
		**small good.  Will never need to split over more than 2 bins********************;
		if (y`base_year'_frac[`i'] < 0.10){;
	
			**strictly interior good;
			if (`cum_sum'>=`lower')&(`cum_sum'<=`upper'){;
				replace bin`bin_num' = 1 in `i';
			};
		
			**handle the borderline good;
			if (`cum_sum'>`upper')&(`cum_sum_old'<`upper'){;
				replace bin`bin_num' = (`upper'-`cum_sum_old')*y`base_year'_total / y`base_year'[`i'] in `i';
				local bin_num = `bin_num' + 1;
				replace bin`bin_num' = 1 - (`upper'-`cum_sum_old')*y`base_year'_total / y`base_year'[`i'] in `i';
				local lower = `lower' + 0.1;
				local upper = `upper' + 0.1;
			};
		
		};   
		*********************************************************************************;
		
		
		**handle a good that is greater than 0.10 of trade*******************************;
		local used = 0;
		if (y`base_year'_frac[`i'] >= 0.10){;	
	
			replace bin`bin_num' = (`upper'-`cum_sum_old')*y`base_year'_total / y`base_year'[`i'] in `i';
			local used =  `used' + (`upper'-`cum_sum_old')*y`base_year'_total / y`base_year'[`i'];
				di `used' "  " `i';
				
				
			while( ((1-`used')*y`base_year'_frac[`i']) >= 0.1){;
				local bin_num = `bin_num' + 1;
				local lower = `lower' + 0.1;
				local upper = `upper' + 0.1;
		
				replace bin`bin_num' = 0.1*y`base_year'_total / y`base_year'[`i'] in `i';
				local used = `used' + 0.1*y`base_year'_total / y`base_year'[`i'];
			};
				di `used' "  " `i';
			if( ( (1-`used')*y`base_year'_frac[`i'] < 0.1 ) & ( (1-`used')*y`base_year'_frac[`i'] > 0.0001 ) ){;
			di "here";
				local bin_num = `bin_num' + 1;
				local lower = `lower' + 0.1;
				local upper = `upper' + 0.1;
			
				replace bin`bin_num' = (1-`used') in `i';
			};
		};
		**********************************************************************************;
	};
	
	local cum_sum_old=`cum_sum';
	local i = `i'+1;		
};


**Count number of goods in each bin***************************************************;
preserve;
collapse (sum) bin*;
forvalues j=1(1)10{;
	local num`j' = bin`j';
	};
restore;
**************************************************************************************;

**Share of each bin at end of sample period.******************************************;
forvalues j=1(1)10{;
	gen after`j' = bin`j'*y`end_year'/y`end_year'_total;
};

preserve;
collapse (sum) after*;
forvalues j=1(1)10{;
	local post`j' = after`j';
};
restore;
***************************************************************************************;

**The time series of the least traded good share***************************************;
foreach j in `years_2'{;
	gen temp`j' = bin1*y`j';
	qui sum temp`j';
	local least_share_`j' = `r(sum)'/y`j'_total;
};
***************************************************************************************;
		

******************Create the output file for the bar graphs****************************;
file open fout using `filename_bar', w replace;
file write fout "bin" _tab "value" _tab "number" _newline;
forvalue j=1(1)10{;
	local temp = `j'/10;
	file write fout "`temp'" _tab "`post`j''" _tab "`num`j''" _newline;
};
file close fout;
***************************************************************************************;


******************Create the output file for the time series graphs*********************;
file open fout using `filename_tss', w replace;                  
file write fout  "year" _tab "share" _newline;
foreach j in `years_2'{;
	file write fout "`j'" _tab "`least_share_`j''" _newline;
};
file close fout;
***************************************************************************************;

